diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-timing-attributes.cc ns-3.42/examples/wireless/wifi-timing-attributes.cc
--- ns-3.41/examples/wireless/wifi-timing-attributes.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-timing-attributes.cc	2024-05-29 15:29:46.916073000 -0700
@@ -57,16 +57,16 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t slot = 9;          // slot time in microseconds
-    uint32_t sifs = 10;         // SIFS duration in microseconds
-    uint32_t pifs = 19;         // PIFS duration in microseconds
-    double simulationTime = 10; // simulation time in seconds
+    uint32_t slot{9};           // slot time in microseconds
+    uint32_t sifs{10};          // SIFS duration in microseconds
+    uint32_t pifs{19};          // PIFS duration in microseconds
+    Time simulationTime{"10s"}; // Simulation time
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("slot", "Slot time in microseconds", slot);
     cmd.AddValue("sifs", "SIFS duration in microseconds", sifs);
     cmd.AddValue("pifs", "PIFS duration in microseconds", pifs);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.Parse(argc, argv);
 
     // Since default reference loss is defined for 5 GHz, it needs to be changed when operating
@@ -146,7 +146,7 @@
     UdpServerHelper server(port);
     ApplicationContainer serverApp = server.Install(wifiStaNode.Get(0));
     serverApp.Start(Seconds(0.0));
-    serverApp.Stop(Seconds(simulationTime + 1));
+    serverApp.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper client(staNodeInterface.GetAddress(0), port);
     client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -155,18 +155,18 @@
 
     ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
     clientApp.Start(Seconds(1.0));
-    clientApp.Stop(Seconds(simulationTime + 1));
+    clientApp.Stop(simulationTime + Seconds(1.0));
 
     // Populate routing table
     Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
     // Set simulation time and launch simulation
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
     // Get and print results
-    uint64_t totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
-    double throughput = totalPacketsThrough * 1472 * 8 / (simulationTime * 1000000.0); // Mbit/s
+    double totalPacketsThrough = DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
+    auto throughput = totalPacketsThrough * 1472 * 8 / simulationTime.GetMicroSeconds(); // Mbit/s
     std::cout << "Throughput: " << throughput << " Mbit/s" << std::endl;
 
     Simulator::Destroy();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-txop-aggregation.cc ns-3.42/examples/wireless/wifi-txop-aggregation.cc
--- ns-3.41/examples/wireless/wifi-txop-aggregation.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-txop-aggregation.cc	2024-05-29 15:29:46.916073000 -0700
@@ -59,7 +59,7 @@
 //
 // The user can select the distance between the stations and the APs, can enable/disable the RTS/CTS
 // mechanism and can modify the duration of a TXOP. Example: ./ns3 run "wifi-txop-aggregation
-// --distance=10 --enableRts=0 --simulationTime=20"
+// --distance=10 --enableRts=0 --simulationTime=20s"
 //
 // The output prints the throughput and the maximum TXOP duration measured for the 4 cases/networks
 // described above. When default aggregation parameters are enabled, the
@@ -108,19 +108,19 @@
 int
 main(int argc, char* argv[])
 {
-    uint32_t payloadSize = 1472; // bytes
-    double simulationTime = 10;  // seconds
-    double txopLimit = 3520;     // microseconds
-    double distance = 5;         // meters
-    bool enableRts = false;
-    bool enablePcap = false;
-    bool verifyResults = false; // used for regression
+    uint32_t payloadSize{1472}; // bytes
+    Time simulationTime{"10s"};
+    double txopLimit{3520}; // microseconds
+    double distance{5};     // meters
+    bool enableRts{false};
+    bool enablePcap{false};
+    bool verifyResults{false}; // used for regression
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("payloadSize", "Payload size in bytes", payloadSize);
     cmd.AddValue("enableRts", "Enable or disable RTS/CTS", enableRts);
     cmd.AddValue("txopLimit", "TXOP duration in microseconds", txopLimit);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
@@ -173,6 +173,8 @@
                 SsidValue(ssid),
                 "EnableBeaconJitter",
                 BooleanValue(false));
+    // Modify EDCA configuration (TXOP limit) for AC_BE
+    mac.SetEdca(AC_BE, "TxopLimits", StringValue(std::to_string(txopLimit) + "us"));
     apDeviceA = wifi.Install(phy, mac, wifiApNodes.Get(0));
 
     // Modify EDCA configuration (TXOP limit) for AC_BE
@@ -182,7 +184,6 @@
     Ptr<QosTxop> edca;
     wifi_dev->GetMac()->GetAttribute("BE_Txop", ptr);
     edca = ptr.Get<QosTxop>();
-    edca->SetTxopLimit(MicroSeconds(txopLimit));
 
     // Trace TXOP duration for BE on AP A
     TxopDurationTracer netA;
@@ -205,6 +206,8 @@
                 SsidValue(ssid),
                 "EnableBeaconJitter",
                 BooleanValue(false));
+    // Modify EDCA configuration (TXOP limit) for AC_BE
+    mac.SetEdca(AC_BE, "TxopLimits", StringValue(std::to_string(txopLimit) + "us"));
     apDeviceB = wifi.Install(phy, mac, wifiApNodes.Get(1));
 
     // Disable A-MPDU
@@ -212,10 +215,8 @@
     wifi_dev = DynamicCast<WifiNetDevice>(dev);
     wifi_dev->GetMac()->SetAttribute("BE_MaxAmpduSize", UintegerValue(0));
 
-    // Modify EDCA configuration (TXOP limit) for AC_BE
     wifi_dev->GetMac()->GetAttribute("BE_Txop", ptr);
     edca = ptr.Get<QosTxop>();
-    edca->SetTxopLimit(MicroSeconds(txopLimit));
 
     // Trace TXOP duration for BE on AP B
     TxopDurationTracer netB;
@@ -240,6 +241,8 @@
                 SsidValue(ssid),
                 "EnableBeaconJitter",
                 BooleanValue(false));
+    // Modify EDCA configuration (TXOP limit) for AC_BE
+    mac.SetEdca(AC_BE, "TxopLimits", StringValue(std::to_string(txopLimit) + "us"));
     apDeviceC = wifi.Install(phy, mac, wifiApNodes.Get(2));
 
     // Disable A-MPDU and enable A-MSDU with the highest maximum size allowed by the standard (7935
@@ -249,10 +252,8 @@
     wifi_dev->GetMac()->SetAttribute("BE_MaxAmpduSize", UintegerValue(0));
     wifi_dev->GetMac()->SetAttribute("BE_MaxAmsduSize", UintegerValue(7935));
 
-    // Modify EDCA configuration (TXOP limit) for AC_BE
     wifi_dev->GetMac()->GetAttribute("BE_Txop", ptr);
     edca = ptr.Get<QosTxop>();
-    edca->SetTxopLimit(MicroSeconds(txopLimit));
 
     // Trace TXOP duration for BE on AP C
     TxopDurationTracer netC;
@@ -277,6 +278,8 @@
                 SsidValue(ssid),
                 "EnableBeaconJitter",
                 BooleanValue(false));
+    // Modify EDCA configuration (TXOP limit) for AC_BE
+    mac.SetEdca(AC_BE, "TxopLimits", StringValue(std::to_string(txopLimit) + "us"));
     apDeviceD = wifi.Install(phy, mac, wifiApNodes.Get(3));
 
     // Enable A-MPDU with a smaller size than the default one and
@@ -286,10 +289,8 @@
     wifi_dev->GetMac()->SetAttribute("BE_MaxAmpduSize", UintegerValue(32768));
     wifi_dev->GetMac()->SetAttribute("BE_MaxAmsduSize", UintegerValue(3839));
 
-    // Modify EDCA configuration (TXOP limit) for AC_BE
     wifi_dev->GetMac()->GetAttribute("BE_Txop", ptr);
     edca = ptr.Get<QosTxop>();
-    edca->SetTxopLimit(MicroSeconds(txopLimit));
 
     // Trace TXOP duration for BE on AP D
     TxopDurationTracer netD;
@@ -350,7 +351,7 @@
     UdpServerHelper serverA(port);
     ApplicationContainer serverAppA = serverA.Install(wifiStaNodes.Get(0));
     serverAppA.Start(Seconds(0.0));
-    serverAppA.Stop(Seconds(simulationTime + 1));
+    serverAppA.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientA(StaInterfaceA.GetAddress(0), port);
     clientA.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -359,12 +360,12 @@
 
     ApplicationContainer clientAppA = clientA.Install(wifiApNodes.Get(0));
     clientAppA.Start(Seconds(1.0));
-    clientAppA.Stop(Seconds(simulationTime + 1));
+    clientAppA.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverB(port);
     ApplicationContainer serverAppB = serverB.Install(wifiStaNodes.Get(1));
     serverAppB.Start(Seconds(0.0));
-    serverAppB.Stop(Seconds(simulationTime + 1));
+    serverAppB.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientB(StaInterfaceB.GetAddress(0), port);
     clientB.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -373,12 +374,12 @@
 
     ApplicationContainer clientAppB = clientB.Install(wifiApNodes.Get(1));
     clientAppB.Start(Seconds(1.0));
-    clientAppB.Stop(Seconds(simulationTime + 1));
+    clientAppB.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverC(port);
     ApplicationContainer serverAppC = serverC.Install(wifiStaNodes.Get(2));
     serverAppC.Start(Seconds(0.0));
-    serverAppC.Stop(Seconds(simulationTime + 1));
+    serverAppC.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientC(StaInterfaceC.GetAddress(0), port);
     clientC.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -387,12 +388,12 @@
 
     ApplicationContainer clientAppC = clientC.Install(wifiApNodes.Get(2));
     clientAppC.Start(Seconds(1.0));
-    clientAppC.Stop(Seconds(simulationTime + 1));
+    clientAppC.Stop(simulationTime + Seconds(1.0));
 
     UdpServerHelper serverD(port);
     ApplicationContainer serverAppD = serverD.Install(wifiStaNodes.Get(3));
     serverAppD.Start(Seconds(0.0));
-    serverAppD.Stop(Seconds(simulationTime + 1));
+    serverAppD.Stop(simulationTime + Seconds(1.0));
 
     UdpClientHelper clientD(StaInterfaceD.GetAddress(0), port);
     clientD.SetAttribute("MaxPackets", UintegerValue(4294967295U));
@@ -401,7 +402,7 @@
 
     ApplicationContainer clientAppD = clientD.Install(wifiApNodes.Get(3));
     clientAppD.Start(Seconds(1.0));
-    clientAppD.Stop(Seconds(simulationTime + 1));
+    clientAppD.Stop(simulationTime + Seconds(1.0));
 
     if (enablePcap)
     {
@@ -415,18 +416,18 @@
         phy.EnablePcap("STA_D", staDeviceD.Get(0));
     }
 
-    Simulator::Stop(Seconds(simulationTime + 1));
+    Simulator::Stop(simulationTime + Seconds(1.0));
     Simulator::Run();
 
     // Show results
-    uint64_t totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
-    uint64_t totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
+    double totalPacketsThroughA = DynamicCast<UdpServer>(serverAppA.Get(0))->GetReceived();
+    double totalPacketsThroughB = DynamicCast<UdpServer>(serverAppB.Get(0))->GetReceived();
+    double totalPacketsThroughC = DynamicCast<UdpServer>(serverAppC.Get(0))->GetReceived();
+    double totalPacketsThroughD = DynamicCast<UdpServer>(serverAppD.Get(0))->GetReceived();
 
     Simulator::Destroy();
 
-    double throughput = totalPacketsThroughA * payloadSize * 8 / (simulationTime * 1000000.0);
+    auto throughput = totalPacketsThroughA * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Default configuration (A-MPDU aggregation enabled, 65kB): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 57.5 || throughput > 58.5))
@@ -447,7 +448,7 @@
         }
     }
 
-    throughput = totalPacketsThroughB * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughB * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "Aggregation disabled: " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 38 || throughput > 39))
@@ -467,7 +468,7 @@
         }
     }
 
-    throughput = totalPacketsThroughC * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughC * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "A-MPDU disabled and A-MSDU enabled (8kB): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 52 || throughput > 53))
@@ -487,7 +488,7 @@
         }
     }
 
-    throughput = totalPacketsThroughD * payloadSize * 8 / (simulationTime * 1000000.0);
+    throughput = totalPacketsThroughD * payloadSize * 8 / simulationTime.GetMicroSeconds();
     std::cout << "A-MPDU enabled (32kB) and A-MSDU enabled (4kB): " << '\n'
               << "  Throughput = " << throughput << " Mbit/s" << '\n';
     if (verifyResults && (throughput < 58 || throughput > 59))
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/examples/wireless/wifi-vht-network.cc ns-3.42/examples/wireless/wifi-vht-network.cc
--- ns-3.41/examples/wireless/wifi-vht-network.cc	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/examples/wireless/wifi-vht-network.cc	2024-05-29 15:29:46.916073000 -0700
@@ -62,19 +62,19 @@
 int
 main(int argc, char* argv[])
 {
-    bool udp = true;
-    bool useRts = false;
-    double simulationTime = 10; // seconds
-    double distance = 1.0;      // meters
-    int mcs = -1;               // -1 indicates an unset value
-    double minExpectedThroughput = 0;
-    double maxExpectedThroughput = 0;
+    bool udp{true};
+    bool useRts{false};
+    Time simulationTime{"10s"};
+    double distance{1.0}; // meters
+    int mcs{-1};          // -1 indicates an unset value
+    double minExpectedThroughput{0.0};
+    double maxExpectedThroughput{0.0};
 
     CommandLine cmd(__FILE__);
     cmd.AddValue("distance",
                  "Distance in meters between the station and the access point",
                  distance);
-    cmd.AddValue("simulationTime", "Simulation time in seconds", simulationTime);
+    cmd.AddValue("simulationTime", "Simulation time", simulationTime);
     cmd.AddValue("udp", "UDP if set to 1, TCP otherwise", udp);
     cmd.AddValue("useRts", "Enable/disable RTS/CTS", useRts);
     cmd.AddValue("mcs", "if set, limit testing to a specific MCS (0-9)", mcs);
@@ -178,6 +178,10 @@
                 NetDeviceContainer apDevice;
                 apDevice = wifi.Install(phy, mac, wifiApNode);
 
+                int64_t streamNumber = 150;
+                streamNumber += wifi.AssignStreams(apDevice, streamNumber);
+                streamNumber += wifi.AssignStreams(staDevice, streamNumber);
+
                 // mobility.
                 MobilityHelper mobility;
                 Ptr<ListPositionAllocator> positionAlloc = CreateObject<ListPositionAllocator>();
@@ -195,6 +199,8 @@
                 InternetStackHelper stack;
                 stack.Install(wifiApNode);
                 stack.Install(wifiStaNode);
+                streamNumber += stack.AssignStreams(wifiApNode, streamNumber);
+                streamNumber += stack.AssignStreams(wifiStaNode, streamNumber);
 
                 Ipv4AddressHelper address;
                 address.SetBase("192.168.1.0", "255.255.255.0");
@@ -205,6 +211,7 @@
                 apNodeInterface = address.Assign(apDevice);
 
                 /* Setting applications */
+                const auto maxLoad = VhtPhy::GetDataRate(mcs, channelWidth, sgi ? 400 : 800, 1);
                 ApplicationContainer serverApp;
                 if (udp)
                 {
@@ -212,16 +219,21 @@
                     uint16_t port = 9;
                     UdpServerHelper server(port);
                     serverApp = server.Install(wifiStaNode.Get(0));
+                    streamNumber += server.AssignStreams(wifiStaNode.Get(0), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
+                    const auto packetInterval = payloadSize * 8.0 / maxLoad;
 
                     UdpClientHelper client(staNodeInterface.GetAddress(0), port);
                     client.SetAttribute("MaxPackets", UintegerValue(4294967295U));
-                    client.SetAttribute("Interval", TimeValue(Time("0.00002"))); // packets/s
+                    client.SetAttribute("Interval", TimeValue(Seconds(packetInterval)));
                     client.SetAttribute("PacketSize", UintegerValue(payloadSize));
                     ApplicationContainer clientApp = client.Install(wifiApNode.Get(0));
+                    streamNumber += client.AssignStreams(wifiApNode.Get(0), streamNumber);
+
                     clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(Seconds(simulationTime + 1));
+                    clientApp.Stop(simulationTime + Seconds(1.0));
                 }
                 else
                 {
@@ -230,8 +242,11 @@
                     Address localAddress(InetSocketAddress(Ipv4Address::GetAny(), port));
                     PacketSinkHelper packetSinkHelper("ns3::TcpSocketFactory", localAddress);
                     serverApp = packetSinkHelper.Install(wifiStaNode.Get(0));
+                    streamNumber +=
+                        packetSinkHelper.AssignStreams(wifiStaNode.Get(0), streamNumber);
+
                     serverApp.Start(Seconds(0.0));
-                    serverApp.Stop(Seconds(simulationTime + 1));
+                    serverApp.Stop(simulationTime + Seconds(1.0));
 
                     OnOffHelper onoff("ns3::TcpSocketFactory", Ipv4Address::GetAny());
                     onoff.SetAttribute("OnTime",
@@ -239,21 +254,23 @@
                     onoff.SetAttribute("OffTime",
                                        StringValue("ns3::ConstantRandomVariable[Constant=0]"));
                     onoff.SetAttribute("PacketSize", UintegerValue(payloadSize));
-                    onoff.SetAttribute("DataRate", DataRateValue(1000000000)); // bit/s
+                    onoff.SetAttribute("DataRate", DataRateValue(maxLoad));
                     AddressValue remoteAddress(
                         InetSocketAddress(staNodeInterface.GetAddress(0), port));
                     onoff.SetAttribute("Remote", remoteAddress);
                     ApplicationContainer clientApp = onoff.Install(wifiApNode.Get(0));
+                    streamNumber += onoff.AssignStreams(wifiApNode.Get(0), streamNumber);
+
                     clientApp.Start(Seconds(1.0));
-                    clientApp.Stop(Seconds(simulationTime + 1));
+                    clientApp.Stop(simulationTime + Seconds(1.0));
                 }
 
                 Ipv4GlobalRoutingHelper::PopulateRoutingTables();
 
-                Simulator::Stop(Seconds(simulationTime + 1));
+                Simulator::Stop(simulationTime + Seconds(1.0));
                 Simulator::Run();
 
-                uint64_t rxBytes = 0;
+                auto rxBytes = 0.0;
                 if (udp)
                 {
                     rxBytes = payloadSize * DynamicCast<UdpServer>(serverApp.Get(0))->GetReceived();
@@ -262,7 +279,7 @@
                 {
                     rxBytes = DynamicCast<PacketSink>(serverApp.Get(0))->GetTotalRx();
                 }
-                double throughput = (rxBytes * 8) / (simulationTime * 1000000.0); // Mbit/s
+                auto throughput = (rxBytes * 8) / simulationTime.GetMicroSeconds(); // Mbit/s
 
                 Simulator::Destroy();
 
@@ -270,7 +287,7 @@
                           << sgi << "\t\t\t" << throughput << " Mbit/s" << std::endl;
 
                 // test first element
-                if (mcs == 0 && channelWidth == 20 && !sgi)
+                if (mcs == minMcs && channelWidth == 20 && !sgi)
                 {
                     if (throughput < minExpectedThroughput)
                     {
@@ -279,7 +296,7 @@
                     }
                 }
                 // test last element
-                if (mcs == 9 && channelWidth == 160 && sgi)
+                if (mcs == maxMcs && channelWidth == 160 && sgi)
                 {
                     if (maxExpectedThroughput > 0 && throughput > maxExpectedThroughput)
                     {
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/ns3 ns-3.42/ns3
--- ns-3.41/ns3	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/ns3	2024-05-29 15:29:46.916073000 -0700
@@ -10,7 +10,7 @@
 import subprocess
 import sys
 
-ns3_path = os.path.dirname(os.path.abspath(__file__))
+ns3_path = os.path.dirname(os.path.realpath(os.path.abspath(__file__)))
 append_to_ns3_path = functools.partial(os.path.join, ns3_path)
 out_dir = os.sep.join([ns3_path, "build"])
 lock_file = os.sep.join([ns3_path, ".lock-ns3_%s_build" % sys.platform])
@@ -618,7 +618,7 @@
 
 
 def remove_dir(dir_to_remove, dry_run, directory_qualifier=""):
-    dir_to_remove = os.path.abspath(dir_to_remove)
+    dir_to_remove = os.path.realpath(os.path.abspath(dir_to_remove))
     if os.path.exists(dir_to_remove):
         if ".." in os.path.relpath(dir_to_remove, ns3_path) or os.path.abspath(
             dir_to_remove
@@ -645,6 +645,7 @@
 
 
 def remove_file(file_to_remove, dry_run):
+    file_to_remove = os.path.realpath(file_to_remove)
     if os.path.exists(file_to_remove):
         print_and_buffer("rm -R %s" % os.path.relpath(file_to_remove, ns3_path))
         if not dry_run:
@@ -1225,7 +1226,7 @@
         print("Target to build does not exist: %s" % program_path)
         exit(1)
 
-    if "scratch" in program_path:
+    if "scratch" in os.path.relpath(program_path, ns3_path):
         # Get the path to the program and replace slashes with underlines
         # to get unique targets for CMake, preventing collisions with modules examples
         return program_name.replace(out_dir, "").replace("/", "_")[1:]
@@ -1412,6 +1413,9 @@
             debugging_software.extend(
                 [check_program_installed("valgrind"), "--leak-check=full", "--show-leak-kinds=all"]
             )
+            suppressions_file = os.path.join(ns3_path, ".ns3.supp")
+            if os.path.exists(suppressions_file):
+                debugging_software.append(f"--suppressions={suppressions_file}")
 
         # running gdb?
         if args.gdb:
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/pyproject.toml ns-3.42/pyproject.toml
--- ns-3.41/pyproject.toml	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/pyproject.toml	2024-05-29 15:29:46.916073000 -0700
@@ -5,7 +5,7 @@
     "setuptools>=45",
     "setuptools_scm[toml]>=6.0",
     "cmake-build-extension>=0.4",
-    "cppyy==2.4.2",
+    "cppyy==3.1.2",
 ]
 
 [tool.setuptools_scm]
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/setup.cfg ns-3.42/setup.cfg
--- ns-3.41/setup.cfg	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/setup.cfg	2024-05-29 15:29:46.916073000 -0700
@@ -40,5 +40,5 @@
 zip_safe = False
 python_requires = >=3.6
 install_requires =
-    cppyy==2.4.2
+    cppyy==3.1.2
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/CMakeLists.txt ns-3.42/src/antenna/CMakeLists.txt
--- ns-3.41/src/antenna/CMakeLists.txt	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/src/antenna/CMakeLists.txt	2024-05-29 15:29:46.916073000 -0700
@@ -1,6 +1,61 @@
+# Check for dependencies and add sources accordingly
+check_cxx_source_compiles(
+  "#include <cmath>
+    int main()
+    {
+      return std::cyl_bessel_j(1, 1);
+    }"
+  HAVE_STD_BESSEL_FUNC
+)
+
+set(circular_aperture_antenna_sources)
+set(circular_aperture_antenna_headers)
+set(circular_aperture_antenna_test_sources)
+
+if(${HAVE_STD_BESSEL_FUNC})
+  set(circular_aperture_antenna_sources
+      model/circular-aperture-antenna-model.cc
+  )
+  set(circular_aperture_antenna_headers
+      model/circular-aperture-antenna-model.h
+  )
+  set(circular_aperture_antenna_test_sources
+      test/test-circular-aperture-antenna.cc
+  )
+  message(STATUS "Standard library Bessel function has been found")
+else()
+  check_include_files(
+    "boost/math/special_functions/bessel.hpp"
+    HAVE_BOOST_BESSEL_FUNC
+    LANGUAGE
+    CXX
+  )
+  if(${HAVE_BOOST_BESSEL_FUNC})
+    set(circular_aperture_antenna_sources
+        model/circular-aperture-antenna-model.cc
+    )
+    set(circular_aperture_antenna_headers
+        model/circular-aperture-antenna-model.h
+    )
+    set(circular_aperture_antenna_test_sources
+        test/test-circular-aperture-antenna.cc
+    )
+    add_definitions(-DNEED_AND_HAVE_BOOST_BESSEL_FUNC)
+    message(STATUS "Boost Bessel function has been found.")
+  else()
+    message(
+      STATUS
+        "Boost Bessel function is required for CircularApertureAntennaModel"
+        " on platforms using Clang libc++ such as macOS."
+        " You may need to clean up the CMake cache after installing it to pass this check."
+    )
+  endif()
+endif()
+
 build_lib(
   LIBNAME antenna
   SOURCE_FILES
+    ${circular_aperture_antenna_sources}
     model/angles.cc
     model/antenna-model.cc
     model/cosine-antenna-model.cc
@@ -10,6 +65,7 @@
     model/three-gpp-antenna-model.cc
     model/uniform-planar-array.cc
   HEADER_FILES
+    ${circular_aperture_antenna_headers}
     model/angles.h
     model/antenna-model.h
     model/cosine-antenna-model.h
@@ -20,10 +76,11 @@
     model/uniform-planar-array.h
   LIBRARIES_TO_LINK ${libcore}
   TEST_SOURCES
+    ${circular_aperture_antenna_test_sources}
     test/test-angles.cc
+    test/test-cosine-antenna.cc
     test/test-degrees-radians.cc
     test/test-isotropic-antenna.cc
-    test/test-cosine-antenna.cc
     test/test-parabolic-antenna.cc
     test/test-uniform-planar-array.cc
 )
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/doc/Makefile ns-3.42/src/antenna/doc/Makefile
--- ns-3.41/src/antenna/doc/Makefile	2024-02-09 14:44:07.845789700 -0800
+++ ns-3.42/src/antenna/doc/Makefile	2024-05-29 15:29:46.916073000 -0700
@@ -40,7 +40,7 @@
 	@if test x$($@_width) != x; then $(RESCALE) $($@_width) $@ ; fi
 
 # You can set these variables from the command line.
-SPHINXOPTS    =
+SPHINXOPTS    = -W --keep-going
 SPHINXBUILD   = sphinx-build
 PAPER         =
 BUILDDIR      = build
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.41/src/antenna/model/angles.cc ns-3.42/src/antenna/model/angles.cc
--- ns-3.41/src/antenna/model/angles.cc	2024-02-09 14:44:07.849789600 -0800
+++ ns-3.42/src/antenna/model/angles.cc	2024-05-29 15:29:46.916073000 -0700
@@ -210,8 +210,9 @@
     // azimuth and inclination angles for zero-length vectors are not defined
     if (v.x == 0.0 && v.y == 0.0 && v.z == 0.0)
     {
-        m_azimuth = NAN;
-        m_inclination = NAN;
+        // assume x and length equals to 1 mm to avoid nans
+        m_azimuth = std::atan2(v.y, 0.001);
+        m_inclination = std::acos(v.z / 0.001);
     }
 
     NormalizeAngles();
